#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#include "main.h"
#include "callbacks.h"
#include "support.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full(G_OBJECT(component), name, \
    gtk_widget_ref(widget),(GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data(G_OBJECT(component), name, widget)

GtkWidget*
create_cropper_window(void)
{
  GtkWidget *cropper_window;
  GtkWidget *dialog_vbox1;
  GtkWidget *status;
  GtkWidget *label1;
  GtkWidget *label2;


  cropper_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name(cropper_window, "cropper_window");
  gtk_container_set_border_width(GTK_CONTAINER(cropper_window), 6);
  gtk_window_set_title(GTK_WINDOW(cropper_window), "cropper-0.2");

  dialog_vbox1 = gtk_vbox_new(FALSE, 6);
  gtk_widget_set_name(dialog_vbox1, "dialog_vbox1");
  gtk_widget_show(dialog_vbox1);
  gtk_container_add(GTK_CONTAINER(cropper_window), dialog_vbox1);


  status = gtk_hbox_new(FALSE, 0);
  gtk_widget_set_name(status, "status");
  gtk_widget_show(status);
  gtk_box_pack_end(GTK_BOX(dialog_vbox1), status, FALSE, FALSE, 0);

  label1 = gtk_label_new("zoom:");
  gtk_widget_set_name(label1, "label1");
  gtk_widget_show(label1);
  gtk_box_pack_start(GTK_BOX(status), label1, FALSE, FALSE, 0);

  label2 = gtk_label_new("1.0");
  gtk_widget_set_name(label2, "label2");
  gtk_widget_show(label2);
  gtk_box_pack_start(GTK_BOX(status), label2, FALSE, FALSE, 0);

/* image_area */
  image_buffer = gdk_pixbuf_new_from_file(image_filename, NULL);
  image_area = gtk_image_new_from_pixbuf(image_buffer);

  gtk_widget_set_name(image_area, "image_area");
  gtk_widget_show(image_area);
  gtk_box_pack_start(GTK_BOX(dialog_vbox1), image_area, TRUE, TRUE, 0);





g_signal_connect(G_OBJECT(cropper_window), "show",
                 G_CALLBACK(on_cropper_window_create), NULL);

g_signal_connect(G_OBJECT(cropper_window), "destroy",
                 G_CALLBACK(on_cropper_window_destroy), NULL);

g_signal_connect(cropper_window, "key-press-event",
                 G_CALLBACK(on_key_press), NULL);


  /* Store pointers to all widgets, for use by lookup_widget(). */

  GLADE_HOOKUP_OBJECT_NO_REF(cropper_window, cropper_window, "cropper_window");
  GLADE_HOOKUP_OBJECT(cropper_window, dialog_vbox1, "dialog_vbox1");

  GLADE_HOOKUP_OBJECT(cropper_window, label1, "label1");
  GLADE_HOOKUP_OBJECT(cropper_window, label2, "label2");
  GLADE_HOOKUP_OBJECT(cropper_window, status, "status");
  GLADE_HOOKUP_OBJECT(cropper_window, image_area, "image_area");
  GLADE_HOOKUP_OBJECT(cropper_window,(GtkWidget*) image_buffer, "image_buffer");


  return cropper_window;
}









/*
  gtk_container_set_border_width(GTK_CONTAINER(hbox1), 5);

  label1 = gtk_label_new("<b>Selection</b>");
  gtk_label_set_use_markup(GTK_LABEL(label1), TRUE);
  gtk_misc_set_alignment(GTK_MISC(label1), 0, 0.5);

  gtk_table_set_row_spacings(GTK_TABLE(table2), 6);
  gtk_table_set_col_spacings(GTK_TABLE(table2), 6);

  gtk_table_attach(GTK_TABLE(table2), label3, 0, 1, 0, 1,(GtkAttachOptions)(GTK_FILL),
                  (GtkAttachOptions)(0), 0, 0);
  gtk_misc_set_alignment(GTK_MISC(label3), 0, 0.5);

  frame1 = gtk_frame_new(NULL);
  gtk_widget_set_name(frame1, "frame1");
  gtk_widget_show(frame1);
  gtk_box_pack_start(GTK_BOX(vbox5), frame1, TRUE, TRUE, 0);
  gtk_frame_set_shadow_type(GTK_FRAME(frame1), GTK_SHADOW_NONE);

  vbox7 = gtk_vbox_new(FALSE, 6);
  gtk_widget_set_name(vbox7, "vbox7");
  gtk_widget_show(vbox7);
  gtk_container_add(GTK_CONTAINER(frame1), vbox7);

g_signal_connect(G_OBJECT(lookup_widget(cropper_window, "crop_x_spinbutton")), "value_changed",
                 G_CALLBACK(selection_x_value_changed_cb), data);
g_signal_connect(G_OBJECT(lookup_widget(cropper_window, "crop_image")), "selection_changed",
                 G_CALLBACK(selection_changed_cb), data);
g_signal_connect(G_OBJECT(lookup_widget(cropper_window, "ratio_swap_button")), "clicked",
                 G_CALLBACK(ratio_swap_button_cb), NULL);
g_signal_connect(G_OBJECT(lookup_widget(cropper_window, "ratio_optionmenu")), "changed",
                 G_CALLBACK(ratio_optionmenu_changed_cb), NULL);
  g_signal_connect(G_OBJECT(ratio_none), "activate",
                   G_CALLBACK(on_ratio_none_activate), NULL);
*/
